#!/opt/puppetlabs/puppet/bin/ruby

require 'socket'
require 'json'

params = JSON.parse(STDIN.read)
destination  = params['destination']
ports  = params['port']

def port_test(dest, port)
  begin
    Socket.tcp(dest, port, connect_timeout:5)
  rescue Errno::ECONNREFUSED, Errno::EHOSTUNREACH, Errno::ETIMEDOUT
    return false
  end
  return true
end

results_json = []

ports.split(/\s*,\s*/).each { |port_no|
    # If port is open
    if port_test(destination, port_no)
        result = {
            'destination' => destination.to_s,
            'port' => port_no,
            'result' => 'pass'
        }
    # If port is closed
    else
        result = {
            'destination' => destination.to_s,
            'port' => port_no,
            'result' => 'fail'
        }
    end
    results_json << result
}

puts JSON.pretty_generate(results_json)
